def load_profile(filename):
    """Legge un file di profili e restituisce una lista di coppie residuo - profilo."""
    f = open(filename)
    l = []

    for row in f:
        data = row.split()
        l.append((data[1],data[2]))
    f.close()
    return l

def extract_reference(profiles):
    """Estrae la sequenza di riferimento da una lista di coppie residuo - profilo."""
    return "".join([r for (r,profile) in profiles])

def histogram(profile):
    """Calcola l'istogramma di una sequenza di caratteri."""
    histo = {}
    for c in profile:
        if not c in histo:
            histo[c] = 1
        else:
            histo[c] += 1
    return histo

def most_common(histo):
    """Prende in ingresso un istogramma e restituisce il carattere piu' frequente."""
    char = None
    freq = 0
    for (k,v) in histo.items():
        if v > freq:
            char = k
            freq = v
    return char


def compute_consensus(profiles):
    """Prende in ingresso una lista di profili restituisce la sequenza consenso."""
    # cons = ""
    # for (res,profile) in profiles:
    #     histo = histogram(profile)
    #     cons_res = most_common(histo)
    #     cons += cons_res
    # return cons
    return "".join([most_common(histogram(profile)) for (res,profile) in profiles])

def print_consensus2ref(reference, consensus):
    """Prende in ingresso una sequenza di riferimento ed una sequenza consenso. 
Le stampa aggiungendo l'informazione sulla relazione tra le due nelle varie posizioni.""" 
    for r,c in zip(reference, consensus):
        if c == '-':
            op = 'D'
        elif r == c:
            op = 'C'
        else:
            op = 'M'
        print(r,c,op)


filename = input("Inserire nome file: ")
profiles = load_profile(filename)
reference = extract_reference(profiles)
consensus = compute_consensus(profiles)
print_consensus2ref(reference, consensus)
